use std::collections::{HashSet, VecDeque};

pub fn parse_datastream(stream: &str) -> usize {
    let mut chars: VecDeque<char> = VecDeque::new();
    for (i, char) in stream.chars().enumerate() {
        if i >= 4 {
            chars.pop_front();
        }
        chars.push_back(char);
        if i >= 3 {
            let char_set: HashSet<char> = chars.iter().map(char::clone).collect();
            if char_set.len() == 4 {
                return i;
            }
        }
    }

    panic!("Couldn't find a start marker!")
}
